<!DOCTYPE html>
<html lang="en">
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">

  <!-- Preload assets -->
  <link rel="preload" href="/static/js/application.js" as="script">
  <link rel="preload" href="/static/img/logo.png" as="image">
  <link rel="preload" href="/static/img/clouds.png" as="image">
  <link rel="preload" href="/static/img/grass.png" as="image">
  <link rel="preload" href="/static/img/water.png" as="image">
  <link
  rel="preload"
  href="/static/fonts/cairo.woff2"
  as="font"
  crossorigin
  >
  <link
  rel="preload"
  href="/static/fonts/icons.woff"
  as="font"
  crossorigin
  >

  <!-- preload fonts -->
  <style>
    /** Fonts **/
    @font-face {
      font-display: swap;
      font-family: "Cairo";
      font-style: normal;
      font-weight: 400;
      src: local("Cairo"), local("Cairo-Regular"),
      url("/static/fonts/cairo.woff2")
      format("woff2");
      unicode-range: U+0000-00FF, U+0131, U+0152-0153, U+02BB-02BC, U+02C6,
      U+02DA, U+02DC, U+2000-206F, U+2074, U+20AC, U+2122, U+2191, U+2193,
      U+2212, U+2215, U+FEFF, U+FFFD;
    }

    @font-face {
      font-display: swap;
      font-family: "icons";
      font-weight: normal;
      font-style: normal;
      font-display: block;
      src: url("/static/fonts/icons.woff")
      format("woff");
    }
  </style>

  <!-- -->
  <link rel="icon" href="/static/img/logo.png">
  <link href="/static/css/materialize.min.css" rel="stylesheet">
  <link href="/static/css/style.css" rel="stylesheet">

  <!-- Website metadata -->
  <title>Flipstarter</title>
  <meta property="og:title" content="Flipstarter">
  <meta
  property="og:description"
  content="Fundraiser for Bitcoin Cash infrastructure utilizing assurance contracts to ensure fairness."
  >
  <meta property="og:type" content="website">
  <meta property="og:url" content="https://www.flipstarter.cash/">
  <meta
  property="og:image"
  content="https://flipstarter.bitcoincashnode.org/img/logo.png"
  >
  <meta property="og:image:alt" content="Flipstarter logo image.">
  <meta property="og:article:section" content="Technology">
  <meta property="og:article:tag" content="Bitcoin">
  <meta property="og:article:tag" content="Bitcoin Cash">
  <meta property="og:article:tag" content="BCH">
  <meta property="og:article:tag" content="Cryptocurrencies">
  <meta property="og:article:tag" content="Fundraising">
  <meta property="og:article:tag" content="Infrastructure">
</head>
<body class="clouds">
  <div class="grass">
    <div class="background">
      <!-- Site header -->
      <header class="container row center">
        <h1 class="cols s12 m12 l12">
          <span id="campaignTitle"></span>
        </h1>
      </header>

      <!-- Site content -->
      <main class="container row z-depth-2">
        <!-- Campaign -->
        <article
        id="campaign"
        class="col s12 m12 l8"
        style="margin-bottom: 0.75rem;"
        >
        <h1 style="display: none;">Campaign</h1>

        <!-- Campaign overview -->
        <section id="overview">
          <h2 style="display: none;">Campaign overview</h2>
          <div style="float: left;">
            <span class="valign-wrapper" style="float: left;">
              <i class="icon-access_time"></i>
              <span id="timerLabel" data-string="expiresLabel"></span>
              <b id="campaignExpiration">...</b>
            </span>
          </div>
          <div style="float: right;">
            <span class="valign-wrapper" style="float: left;">
              <i class="icon-bookmark_border"></i>
              <span id="compaignContributionAmount">0.00</span>
              <i>/</i>
              <span id="campaignRequestAmount">-.--</span>
              <b>BCH</b>
            </span>
          </div>
          <div class="progress">
            <div class="determinate" id="campaignProgressBar"></div>
            <div class="determinate" id="campaignContributionBar"></div>
          </div>
        </section>

        <!-- Campaign heading -->
        <header id="campaignAbstract"></header>

        <!-- Campaign donation form -->
        <fieldset id="donateField" class="row"></fieldset>
        <div id="donateStatus" class="col s12 m12 l12 hidden"></div>
        <div id="donateFormContainer">
          <div id="donateForm" class="col s12 m12 l12 hidden">
            <div class="input-field col s1 m1 l1">
              <i class="icon-attach_money money-icon"></i>
            </div>
            <div id="donationSliderContainer" class="input-field col s11 m5 l6">
              <input type="range" min="0" max="100" value="0" step="0.20" class="slider" id="donationSlider">
            </div>
            <div id="donationButtonContainer" class="input-field col s12 m6 l5">
              <button id="donateButton" class="btn waves-effect waves-light green" disabled="disabled">
                <span id="donateText" data-string="donateText"></span>
                <span id="donationAmount"></span>
              </button>
            </div>
          </div>

          <div id="donateSection" class="col s12 m12 hidden">
            <div id="providerButtonsContainer" class="col">
              <div class="col s12 m12 l12">
                <div id="contributionDetailsContainer" class="row">
                  <div id="contributionNameContainer" class="input-field col s12 m12 l12">
                    <i class="icon icon-person_outline prefix"></i>
                    <input id="contributionName" type="text" maxlength="24">
                    <label for="contributionName" data-string="usernameLabel"></label>
                  </div>

                  <div id="contributionCommentContainer" class="input-field col s12 m12 l12">
                    <i class="icon icon-chat_bubble_outline prefix"></i>
                    <input id="contributionComment" type="text" maxlength="120">
                    <label for="contributionComment" data-string="commentLabel"></label>
                  </div>
                </div>
              </div>
              <div class="provider-container col input-field l12 m12 s12">
                <button id="signupDonateButton" class="btn waves-effect waves-light">
                  <span>Contribute using SignUp</span>
                </button>
              </div>
              <div class="provider-container col input-field l12 m12 s12">
                <button id="electrumDonateButton" class="btn waves-effect waves-light">
                  <span>Contribute using Electrum</span>
                </button>
              </div>
            </div>

            <div id="electrumFormContainer" class="col s12 m12 hidden">
              <div class="col">
                <div class="col s12 m12 l3">
                  <small class="step-title" data-string="copyLabel"></small>
                  <textarea rows="5" id="template" name="template"></textarea>
                  <button id="copyTemplateButton" class="btn waves-effect waves-light green" data-string="copyButton"></button>
                </div>
                <div class="col s12 m12 l6">
                  <small class="step-title" data-string="instructionsLabel"></small>
                  <p id="instructions" data-string="instructions"></p>
                  <div id="instructionLinks">
                    <a id="downloadButton" class="btn" href="https://gitlab.com/flipstarter/flipstarter-electron-cash/uploads/ec6b5a7518801c4a278128ac4f296607/flipstarter-1.3.zip">
                      <i class="icon-download"></i>
                      <span data-string="downloadText"></span>
                    </a>
                    <a id="linkInstructionsButton" class="btn" target="_blank" href="https://read.cash/@flipstarter/how-to-support-a-flipstarter-campaign-f27240d9">
                      <i class="icon-info"></i>
                      <span data-string="instructionLink"></span>
                    </a>
                  </div>
                </div>
                <div class="col s12 m12 l3">
                  <small class="step-title" data-string="commitLabel"></small>
                  <textarea rows="5" id="commitment" name="commitment" data-placeholder="PasteHere"></textarea>
                  <button id="commitTransaction" class="btn waves-effect waves-light green" disabled="disabled" data-string="commitButton"></button>
                </div>
              </div>
            </div>
          </div>
        </div>
      </fieldset>

<!-- Campaign details. -->
<section id="campaignDetails" class="row"></section>
</article>

<!-- Campaign sidebar -->
<aside class="col s12 m12 l4">
  <section>
    <h3 style="float: left;">
      <span class="valign-wrapper" style="float: left;">
        <i class="icon-face"></i>
        <b id="campaignRecipientCount">0</b>
        <span data-string="recipientsLabel"></span>
      </span>
    </h3>
    <hr>
    <ul
    id="recipientList"
    class="row"
    style="margin-bottom: 2rem;"
    ></ul>
  </section>

  <section>
    <h3 style="float: left;">
      <span class="valign-wrapper" style="float: left;">
        <i class="icon-favorite_border"></i>
        <b id="campaignContributorCount">0</b>
        <span data-string="contributorsLabel"></span>
      </span>
    </h3>
    <hr>
    <ul id="contributionList">
      <li
      style="
      display: block;
      text-align: center;
      color: rgba(0, 0, 0, 0.5);
      padding: 2rem;
      "
      >
      <i data-string="contributorEmpty1"></i>
      <br>
      <i data-string="contributorEmpty2"></i>
    </li>
  </ul>
</section>
</aside>
<ul
class="col s10 m10 l10 push-s1 push-m1 push-l1"
style="display: flex; justify-content: center; text-align: left;"
>
<li class="col">
  <a
  class="valign-wrapper"
  target="_blank"
  href="https://read.cash/@flipstarter/how-to-support-a-flipstarter-campaign-f27240d9"
  >
  <i class="icon-info"></i>
  &nbsp;
  <span data-string="linkHowTo"></span>
</a>
</li>
<li class="col">
  <a
  class="valign-wrapper"
  target="_blank"
  href="https://read.cash/@flipstarter/flipstarter-faq-66c56b03"
  >
  <i class="icon-info"></i>
  &nbsp;
  <span data-string="linkFAQ"></span>
</a>
</li>
</ul>
</main>

<footer class="center">
  <p>Powered by <a href="https://flipstarter.cash" target="_blank">Flipstarter</a></p>
</footer>

</div>
</div>

<div id="languageSelector" class="fixed-action-btn">
  <b id="currentLanguage" data-string="changeLanguage"></b>
  <a class="btn-floating btn-large green"
  ><i class="large icon-translate"></i
    ></a>
    <ul style="float: right; text-align: right; margin-right: 0.5rem;">
      <li>
        <a
        class="btn-floating purple darken-2"
        style="text-align: center;"
        id="translateEnglish"
        >En</a
        >
      </li>
      <li>
        <a
        class="btn-floating pink darken-2"
        style="text-align: center;"
        id="translateChinese"
        >Cn</a
        >
      </li>
      <li>
        <a
        class="btn-floating red darken-1"
        style="text-align: center;"
        id="translateJapanese"
        >Ja</a
        >
      </li>
      <li>
        <a
        class="btn-floating orange darken-2"
        style="text-align: center;"
        id="translateSpanish"
        >Es</a
        >
      </li>
    </ul>
  </div>

  <!-- -->
  <template id="recipientTemplate">
    <li class="col s6 m6 l12">
      <a>
        <img>
        <span>
          <b></b>
          <i></i>
        </span>
      </a>
    </li>
  </template>
  <template id="contributionTemplate">
    <li>
      <div>
        <div class="contributionWaves"></div>
        <div class="contributionDisplay"></div>
        <span class="contributionPercent"></span>
      </div>
      <span>
        <span>
          <b class="contributionAlias"></b>
          <small class="contributionAmount"></small>
        </span>
        <q class="contributionComment"></q>
      </span>
    </li>
  </template>
  <template id="emptyContributionMessage">
    <li
    style="
    display: block;
    text-align: center;
    color: rgba(0, 0, 0, 0.5);
    padding: 2rem;
    "
    >
    <i data-string="contributorEmpty1"></i>
    <br>
    <i data-string="contributorEmpty2"></i>
  </li>
</template>

<!-- Load the javascript as the last step to ensure fastest load time. -->
<script src="/static/js/application.js"></script>
<script src="https://cdn.signup.cash/provider-v1.3.2.js" integrity="sha512-+ZOW1ooZTMCG1fP/HWiSlLIJkbdMp6dCYBXrVJ1+yR6eBIMUXPl3pHZoK0QvLECkJCcdQjs14AEP4WRYr03z4w==" crossorigin="anonymous"></script>
<script>
  const signup = new Signup.cash({})
  const signupDonationButton = document.getElementById("signupDonateButton")
  const electrumDonationButton = document.getElementById("electrumDonateButton")

  signupDonationButton.addEventListener("click", (async function () {

      try {
        // Get the number of satoshis the user wants to donate.
        const donationAmountElem = document.getElementById("donationAmount");
        const satoshis = donationAmountElem.getAttribute("data-satoshis");

        // If the user wants to donate some satoshis..
        if (satoshis) {

          let recipients = []

          // For each recipient..
          for (const recipientIndex in this.campaign.recipients) {
            const outputValue = this.campaign.recipients[recipientIndex].recipient_satoshis;
            const outputAddress = this.campaign.recipients[recipientIndex].user_address;

            // Add the recipients outputs to the request.
            recipients.push({ value: outputValue, address: outputAddress });
          }

          const req = {
            title: this.campaign.title,
            expires: this.campaign.expires,
            alias: document.getElementById("contributionName").value,
            comment: document.getElementById("contributionComment").value,
            includingFee: this.calculateMinerFee()
          }

          const { payload } = await signup.sendAnyoneCanPayCommitment(
            recipients,
            Number(satoshis), 
            "SATS", 
            req
          );

          document.getElementById("commitment").value = payload

          this.parseCommitment()
        }         

      } catch (err) {

        if (err && err.status === 'ERROR') {
          console.log(err.message)
        }

        this.updateStatus("failed", "statusFailedUnknown", this.translation["statusFailedUnknown"]);
      }
  }).bind(window.flipstarter))

  electrumDonationButton.addEventListener("click", () => {
    const electrumFormContainer = document.getElementById("electrumFormContainer")
    const isHidden = electrumFormContainer.classList.contains("hidden")
    
    if (isHidden) {
      electrumFormContainer.classList.remove("hidden")
    } else {
      electrumFormContainer.classList.add("hidden")
    }
  })
</script>
<!-- -->
<audio src="/static/snd/applause.mp3" id="applause"></audio>
</body>
</html>
